Option Strict Off
Option Explicit On
Imports System
Imports System.IO
Imports System.Text
Imports System.Object
Imports VB = Microsoft.VisualBasic

Friend Class frm1
    Inherits System.Windows.Forms.Form
    '*************************************************************************
    '   Visual Basic.NET VB2005 VISA Keyboard Program               07-17-2014
    '   Copyright 2011 ICS Electronics div Systems West, Inc.
    '
    '   Example Visual Basic Program makes VISA calls
    '   Program is linked to visa-32.vb files
    '   VISAkybd_Help.chm must be in directory with the runing program.
    '   5-22-13 Added baud rate choice for USB 115.2 Kbaud Serial devices. 
    '   3-12-14 Added secondary addresses for GPIB devices.
    '   7-17-14 Fixed cmdCMD loop to call read, was calling lock.
    '**************************************************************************
    'Agilent VISA declarations
    Dim defrm As Long             'Session to Default Resource Manager
    Dim vi As Long                'Session to instrument
    Dim strRes As String          'Fixed length string to hold results
    Dim strVisaErr As New StringBuilder
    Dim strMatch As New StringBuilder

    'ICS Program declarations
    Dim CmdStr As String
    Dim SPACE80S As String
    Public udlink&                 'from create inst link
    Public NL
    Public Sendlock                'Send locked device flag
    Public MsgSentFlg              'set by cmdSend, reset by Timer2
    Public Device                  'instn
    Public term%
    Public IDNTestFlg
    Public CMDloopFlg
    Public LpCount
    Public ResType As String
    Public HSType As String
    Public status As Long
    Public Flags&
    Dim Revdate As String = "07-17-2014"
    Public Errstr As String

    Private Sub frm1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Dim Errstr As Short

        ' Open the default resource manager session
        status = viOpenDefaultRM(defrm)                 'open VISA session
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        txtRev.Text = "Revised S10 " + Revdate
        cmdLinki.Enabled = True
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = False
        cmdCMDtst.Enabled = False
        cmdCMDtstoff.Enabled = False
        cmdSDC.Enabled = False
        cmdSpoll.Enabled = False
        cmdLock.Enabled = False
        cmdUnLock.Enabled = False
        cmdDT.Enabled = False
        cmdExit.Enabled = True
        ckAutoLock.Enabled = False
        ckCR.Enabled = False
        ckLF.Enabled = False
        ckAutoQuery.Checked = 1
        ckByteCnt.Checked = 0
        ckDispAll.Checked = 0
        optRes1.Enabled = True
        optRes2.Enabled = True
        optRes3.Enabled = True
        lbliLock.Visible = False
        lblKeepAliveMsg.Visible = False
        SPACE80S = Space$(100)                          '100 spaces
        NL = Chr(13) + Chr(10)
        txtError.Text = ""                              'clear label and text box
        txtResults.Text = ""
        combCmd.Text = ""
        Device = ""
        IDNTestFlg = 0
        CMDloopFlg = 0
        lblCount.Visible = False
        txtCount.Visible = False
        LpCount = 0
        Timer1.Interval = 200
        txtResults.Enabled = True
        txtError.Enabled = False
        IDNTestFlg = 0
        combCmd.Items.Insert(0, "*esr?")
        combCmd.Items.Insert(1, "*idn?")
        combCmd.Items.Insert(2, "*stb?")
        strVisaErr.Capacity = 100

        Exit Sub

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
    End Sub

    Private Sub optRes1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optRes1.Click
        optRes2.Checked = False
        optRes3.Checked = False
        'optRes1.Checked = True

        ResType = "TCPIP"
        txtIPAddr.Text = "192.168.0.254"
        combInst.Items.Insert(0, "inst0")
        combInst.Items.Insert(1, "inst1")
        combInst.Items.IndexOf(0)
        'combDev.Items.Add("", 0)
        'combDev.Items.IndexOf(0)
        GoTo optRexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
optRexit:
    End Sub

    Private Sub optRes2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optRes2.Click
        Dim I As Integer
        'Dim expr$
        'Dim findhandle&     'vi findRsrc handle
        'Dim retCount        'number found
        'Dim matches$
        'Dim matchest$

        optRes1.Checked = False
        optRes3.Checked = False
        ' optRes2.Checked = True

        ResType = "GPIB"
        For I = 1 To 30
            combDev.Items.Insert(I - 1, (I))
        Next I
        combDev.Items.IndexOf(3)
        txtIPAddr.Text = ""
        combInst.Items.Insert(0, "")
        combInst.Items.IndexOf(0)
        GoTo optR2exit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
optR2exit:
    End Sub

    Private Sub optRes3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optRes3.Click
        Dim I As Integer
        Dim expr$
        Dim findhandle&     'vi findRsrc handle
        Dim retCount        'number found
        Dim matchest$

        optRes1.Checked = False
        optRes2.Checked = False
        'optRes3.Checked = True

        ResType = "VISA"
        expr$ = "?*INSTR"
        retCount = 0
        strMatch = New StringBuilder("                                                 ")
        status = viFindRsrc(defrm, expr$, findhandle&, retCount, strMatch)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        If retCount = 0 Then
            combVRsrc.Text = "None Found"
        Else
            matchest$ = ""
            matchest$ = strMatch.ToString
            If InStr(matchest$, Chr(0)) <> 0 Then
                matchest$ = Microsoft.VisualBasic.Left(matchest$, (InStr(matchest$, Chr(0)) - 1))
            End If
            combVRsrc.Items.Add(matchest$)
            For I = 1 To retCount - 1
                strMatch = New StringBuilder("                                                 ")
                status = viFindNext(findhandle&, strMatch)
                If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
                matchest$ = strMatch.ToString
                If InStr(matchest$, Chr(0)) <> 0 Then
                    matchest$ = Microsoft.VisualBasic.Left(matchest$, (InStr(matchest$, Chr(0)) - 1))
                End If
                combVRsrc.Items.Add(matchest$)
            Next I
            End If
            Call viClose(findhandle&)
            combVRsrc.Items.IndexOf(0)
            GoTo optR3exit

VisaErrorHandler:
            Call viStatusDesc(defrm, status, strVisaErr)
            Errstr = strVisaErr.ToString
            txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
            txtError.Visible = True
            Beep()
optR3exit:
    End Sub

    Private Sub cmdLinki_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLinki.Click
        Dim dev As Integer
        Dim ip As String
        Dim status As Short
        Dim Outbuf As Byte()
        Dim Outstring As String
        Dim bufSize As Integer
        Dim outcount As Integer
        Dim instance As New UTF8Encoding
        Dim L As Integer
        Dim Sec As String

        txtError.Visible = False
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = False
        cmdCMDtst.Enabled = False
        cmdCMDtstoff.Enabled = False
        cmdLock.Enabled = False
        cmdUnLock.Enabled = False
        cmdSDC.Enabled = False
        cmdSpoll.Enabled = False
        ckCR.Enabled = False
        ckLF.Enabled = False
        ckAutoLock.Enabled = False
        ckAutoQuery.Enabled = False
        ckByteCnt.Enabled = False
        combCmd.Text = ""
        If udlink <> 0 Then         'disable any prior device link
            Call viClose(udlink)
            lbliLock.Visible = False
            udlink = 0
        End If
        If ResType = "TCPIP" Then
            Device = combInst.Text
            ip = txtIPAddr.Text
            CmdStr = "TCPIP::" & ip & "::" + Device + "::INSTR"
        ElseIf ResType = "GPIB" Then
            L = Len(combDev.Text)
            If L <= 2 Then
                Device = combDev.Text
                CmdStr = "GPIB0::" + Device + "::INSTR"
            Else
                Device = Mid$(combDev.Text, 1, (L - 2))
                Sec = Mid$(combDev.Text, (L - 1), 2)
                CmdStr = "GPIB0::" + Device + "::" + Sec + "::INSTR"
            End If
        ElseIf ResType = "VISA" Then
            CmdStr = combVRsrc.Text
            Device = combVRsrc.Text
        End If
        status = viOpen(defrm, CmdStr, 0, 0, dev)   'open instrument resource
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        udlink = dev                    'udlink refers to the GPIB device
        'added 5-22-13 for USB serial devices
        If ResType = "VISA" And InStr(combVRsrc.Text, "ASRL") <> 0 Then
            If MessageBox.Show("Change default baud rate from 9600 to 115,200?", "Check Baud Rate", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                status = viSetAttribute(dev, VI_ATTR_ASRL_BAUD, 115200)
                If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
                txtResults.Text = "Link created to instrument at " & Device & "using 115,200 baud"
            Else
                status = viSetAttribute(dev, VI_ATTR_ASRL_BAUD, 9600)
                If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
                txtResults.Text = "Link created to instrument at " & Device & "using 9600 baud"
            End If
            'send CNTL-F to turn off ICS USB/serial device echo
            Outstring = Chr(6)
            Outbuf = instance.GetBytes(Outstring)
            bufSize = Len(Outstring)
            status = viWrite(udlink, Outbuf, bufSize, outcount)
            If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        Else
            txtResults.Text = "Link created to instrument at " & Device
        End If
        cmdSend.Enabled = True          'enable controls
        cmdRead.Enabled = True
        cmdIDNtst.Enabled = True
        cmdIDNtstoff.Enabled = False
        cmdCMDtst.Enabled = True
        cmdCMDtstoff.Enabled = False
        cmdLock.Enabled = True
        cmdUnLock.Enabled = True
        cmdDT.Enabled = True
        cmdSDC.Enabled = True
        cmdSpoll.Enabled = True
        ckCR.Enabled = True
        ckLF.Enabled = True
        ckAutoLock.Enabled = True
        ckCR.CheckState = System.Windows.Forms.CheckState.Unchecked
        ckLF.CheckState = System.Windows.Forms.CheckState.Checked
        ckAutoLock.CheckState = System.Windows.Forms.CheckState.Unchecked
        ckAutoQuery.Enabled = True
        ckByteCnt.Enabled = True
        MsgSentFlg = 1              'sets flag to show that the link was exercized
        GoTo Linkiexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
Linkiexit:
    End Sub

    Private Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
        Dim Outbuf As Byte()
        Dim Outstring As String
        Dim bufSize As Integer
        Dim outcount As Integer
        Dim instance As New UTF8Encoding

        txtError.Visible = False
        If ckAutoLock.CheckState = 1 Then Call cmdLock_Click(cmdLock, New System.EventArgs())
        Sendlock = 1                'set Sendlock flag for read routine
        Outstring = combCmd.Text
        If Outstring = "" Then
            txtResults.Text = "Device command box empty, nothing sent to the device"
            Beep()
            GoTo Sendexit
        End If

        If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
        If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
        Outbuf = instance.GetBytes(Outstring)
        bufSize = Len(Outstring)
        status = viWrite(udlink, Outbuf, bufSize, outcount)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        MsgSentFlg = 1                  'sets flag to show that the link was exercized
        If (ckAutoQuery.CheckState = 1) And (InStr(Outstring, "?") <> 0) Then
            Call cmdRead_Click(cmdRead, New System.EventArgs())
        Else
            txtResults.Text = "Send String => " & Outstring
            If ckAutoLock.CheckState = 1 And (InStr(Outstring, "?") = 0) Then
                Call cmdUnLock_Click(cmdUnLock, New System.EventArgs())
                Sendlock = 0                'reset flag
            End If
        End If
        GoTo Sendexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
Sendexit:
    End Sub

    Private Sub cmdRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRead.Click
        Dim instring As String
        Dim inbuf As Byte()
        Dim InCount As Integer
        Dim bufSize As Integer
        Dim L As Short
        Dim N As Short
        Dim instance As New UTF8Encoding
        Dim instance2 As New ASCIIEncoding

        txtError.Visible = False
        If ckAutoLock.CheckState = 1 And Sendlock = 0 Then Call cmdLock_Click(cmdLock, New System.EventArgs())
        Sendlock = 1                            'set Sendlock flag
        Flags = 0
        inbuf = instance.GetBytes(Space$(100))  '100 spaces
        InCount = 100
        bufSize = 100
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtResults.Text = "Device Read: Waiting for device response"
            txtResults.Refresh()
        End If
        status = viRead(udlink, inbuf, bufSize, InCount)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        MsgSentFlg = 1                      'sets flag to show that the link was exercized
        If ckAutoLock.CheckState = 1 Then
            Call cmdUnLock_Click(cmdUnLock, New System.EventArgs())
            Sendlock = 0
        End If
        instring = instance2.GetString(inbuf)
        If ckDispAll.CheckState = 0 Then
            L = InStr(instring, Chr(13))    'check for CR
            If L <> 0 Then
                instring = VB.Left(instring, L - 1)
            Else
                L = InStr(instring, Chr(10)) 'check for LF
                If L <> 0 Then
                    instring = VB.Left(instring, L - 1)
                End If
            End If
        Else
            L = Len(instring)
            Do Until InStr(instring, Chr(13)) = 0
                N = InStr(instring, Chr(13))
                If N = 1 Then
                    instring = "<cr>" + Mid(instring, 2, L - 2)
                Else
                    instring = Mid(instring, 1, N - 1) + "<cr>" + Mid(instring, N + 1, L - N - 1)
                End If
            Loop
            L = Len(instring)
            Do Until InStr(instring, Chr(10)) = 0
                N = InStr(instring, Chr(10))
                If N = 1 Then
                    instring = "<lf>" + Mid(instring, 2, L - 2)
                Else
                    instring = Mid(instring, 1, N - 1) + "<lf>" + Mid(instring, N + 1, L - N - 1)
                End If
            Loop
        End If
        txtError.Visible = False
        txtResults.Text = RTrim(instring)
        If ckByteCnt.CheckState = 1 Then
            txtResults.Text = txtResults.Text + NL + "Byte count= " + Str(InCount)
        End If
        GoTo Readexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
Readexit:
    End Sub

    Private Sub cmdLock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLock.Click
        Dim lockType As Integer
        Dim locktimeout As Integer
        Dim requestedKey As String
        Dim accessKeystr As String
        Dim accessKey As New StringBuilder

        lockType = VI_EXCLUSIVE_LOCK
        locktimeout = 30000                 '30 seconds
        requestedKey = CStr(VI_NULL)
        accessKeystr = CStr(VI_NULL)
        accessKey = New StringBuilder(accessKeystr)
        status = viLock(udlink, lockType, locktimeout, requestedKey, accessKey)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        txtError.Visible = False
        txtResults.Text = "Device " & Device & " locked"
        lbliLock.Visible = True
        lbliLock.Refresh()
        Sendlock = 1                        'sets locked flag
        MsgSentFlg = 1                      'sets flag to show that the link was exercized
        GoTo lockexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
lockexit:
    End Sub

    Private Sub cmdUnLock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUnLock.Click
        status = viUnlock(udlink)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        txtError.Visible = False
        txtResults.Text = "Device " & Device & " unlocked"
        lbliLock.Visible = False
        Sendlock = 0                'clears locked flag
        MsgSentFlg = 1              'sets flag to show that the link was exercized
        GoTo unlockexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
unlockexit:
    End Sub

    Private Sub cmdSDC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSDC.Click
        txtError.Visible = False
        combCmd.Text = ""
        txtResults.Text = ""

        status = viClear(udlink)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        txtError.Visible = False
        txtResults.Text = "Device Clear sent to device " & Device
        MsgSentFlg = 1                  'sets flag to show that the link was exercized
        GoTo SDCexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
SDCexit:
    End Sub

    Private Sub cmdDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDT.Click
        txtError.Visible = False
        combCmd.Text = ""
        txtResults.Text = ""

        status = viAssertTrigger(udlink, VI_TRIG_PROT_DEFAULT) '11-9-10 was SYNC
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        txtError.Visible = False
        txtResults.Text = "Device Trigger sent to device " & Device
        MsgSentFlg = 1              'sets flag to show that the link was exercized
        GoTo DTexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
DTexit:
    End Sub

    Private Sub cmdSpoll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSpoll.Click
        Dim STBbyte As Short
        txtError.Visible = False
        txtResults.Text = ""
        status = viReadSTB(udlink, STBbyte) 'queries instn status byte
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

        txtResults.Text = "Serial poll response => " & Str(STBbyte)
        MsgSentFlg = 1              'sets flag to show that the link was exercized
        GoTo Spollexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
Spollexit:
    End Sub

    Private Sub cmdIDNtst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdIDNtst.Click
        combCmd.Text = "*idn?"
        Timer1.Interval = 250
        Timer1.Enabled = True
        IDNTestFlg = 1
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = True
    End Sub

    Private Sub cmdIDNtstoff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdIDNtstoff.Click
        IDNTestFlg = 0
        cmdIDNtst.Enabled = True
        cmdIDNtstoff.Enabled = False
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub cmdCMDtst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCMDtst.Click
        If combCmd.Text = "" Then
            Beep()
            txtResults.Text = "No command specified.  Enter a command before starting the Command Loop"
        Else
            CMDloopFlg = 1
            Timer1.Interval = 250
            Timer1.Enabled = True
            cmdCMDtst.Enabled = False
            cmdCMDtstoff.Enabled = True
        End If
    End Sub

    Private Sub cmdCMDtstoff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCMDtstoff.Click
        CMDloopFlg = 0
        cmdCMDtst.Enabled = True
        cmdCMDtstoff.Enabled = False
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
            Timer1.Enabled = False        'turn timer off
        End If
    End Sub

    Private Sub cmdExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExit.Click
        If udlink <> 0 Then 'close device session
            Call viClose(udlink)
            lbliLock.Visible = False
            udlink = 0
        End If
        Call viClose(defrm)             'close main VISA session
        End
    End Sub

    Private Sub ckCR_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckCR.CheckedChanged
        If ckCR.CheckState = 1 Then
            term = 13                   'set termination for CR or EOI
        End If
    End Sub

    Private Sub ckLF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckLF.CheckedChanged
        If ckLF.CheckState = 1 Then
            term = 10                   'set termination for LF or EOI
        End If
    End Sub

    Private Sub ckAutoLock_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckAutoLock.Click
        If ckAutoLock.CheckState = 1 Then
            If Sendlock = 1 Then        'test for existing lock
                ckAutoLock.CheckState = System.Windows.Forms.CheckState.Unchecked
            Else
                cmdLock.Enabled = False
                cmdUnLock.Enabled = False
            End If
        Else
            cmdLock.Enabled = True
            cmdUnLock.Enabled = True
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim Outstring$
        Dim outbuf As Byte()
        Dim bufSize&
        Dim outcount&
        Dim instance As New UTF8Encoding
        Dim instance2 As New ASCIIEncoding

        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            GoTo Timerexit
        End If

        If IDNTestFlg = 1 Then
            If ckAutoLock.CheckState = CheckState.Checked Then
                Call cmdLock_Click(cmdLock, New System.EventArgs())
                Sendlock = 1                    'set Sendlock flag for read routine
            End If

            Outstring$ = "*IDN?"
            If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
            If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
            outbuf = instance.GetBytes(Outstring)
            bufSize = Len(Outstring)
            status = viWrite(udlink, outbuf, bufSize, outcount)
            If (status < VI_SUCCESS) Then GoTo VisaErrorHandler


            If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
                txtResults.Text = "Device Read: Waiting for device response"
                txtResults.Refresh()
            End If
            txtError.Visible = False
            MsgSentFlg = 1                  'sets flag to show that the link was exercized
            If ckAutoQuery.CheckState = CheckState.Checked And (InStr(Outstring$, "?") <> 0) Then
                Call cmdRead_Click(cmdRead, New System.EventArgs())
            End If
        End If

        If CMDloopFlg = 1 Then                                       'loop using the string in the combCmd.text
            If combCmd.Text = "" Then
                Beep()
                txtError.Text = "Command box empty"
                txtError.Visible = True
            Else
                If ckAutoLock.CheckState = CheckState.Checked Then
                    Call cmdLock_Click(cmdLock, New System.EventArgs())
                    Sendlock = 1                    'set Sendlock flag for read routine
                End If
                txtError.Visible = False
                Outstring$ = combCmd.Text
                If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
                If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
                outbuf = instance.GetBytes(Outstring)
                bufSize = Len(Outstring)
                status = viWrite(udlink, outbuf, bufSize, outcount)
                If (status < VI_SUCCESS) Then GoTo VisaErrorHandler

                MsgSentFlg = 1                  'sets flag to show that the link was exercized
                If (ckAutoQuery.CheckState = CheckState.Checked) And (InStr(Outstring$, "?") <> 0) Then
                    Call cmdRead_Click(cmdRead, New System.EventArgs())
                End If
            End If
        End If

Timerexit1: txtCount.Visible = True
        lblCount.Visible = True
        LpCount = LpCount + 1
        txtCount.Text = LpCount
        GoTo Timerexit

VisaErrorHandler:
        Call viStatusDesc(defrm, status, strVisaErr)
        Errstr = strVisaErr.ToString
        txtError.Text = "*** Error: " & Errstr & "VISA Error Message"
        txtError.Visible = True
        Beep()
        If ckAutoLock.CheckState = CheckState.Checked Then Call cmdUnLock_Click(cmdUnLock, New System.EventArgs())
        Sendlock = 0                    'reset flag
        IDNTestFlg = 0
        CMDloopFlg = 0
Timerexit:
    End Sub

    Private Sub cmdHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHelp.Click

        Dim HelpNameSpace As String
        Dim MyPath As String

        MyPath = CurDir()
        HelpNameSpace = "file://" + MyPath + "\VISAkybd_Help.chm"
        'show the contents of the help file
        Help.ShowHelp(Me, HelpNameSpace)
        'Help.ShowHelp(Me, "file://c:\VB.NET2005\VISAkybd.NET\VISAkybd_Help.chm")


    End Sub

    Private Sub combCmd_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles combCmd.KeyDown
        If e.KeyCode = Keys.Enter Then
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        End If
    End Sub

    Private Sub ToolTip1_Popup(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PopupEventArgs) Handles ToolTip1.Popup

    End Sub
End Class
